<!--
/*
* Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
-->
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.claim.mgt.ui.client.ClaimAdminClient" %>
<%@ page import="org.wso2.carbon.claim.mgt.stub.dto.ClaimDialectDTO" %>
<%@ page import="org.wso2.carbon.claim.mgt.stub.dto.ClaimMappingDTO" %>
<%@ page import="org.wso2.carbon.identity.entitlement.ui.dto.BasicRequestDTO" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<jsp:useBean id="entitlementPolicyBean" type="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyBean"
             class="org.wso2.carbon.identity.entitlement.ui.EntitlementPolicyBean" scope="session"/>
<jsp:setProperty name="entitlementPolicyBean" property="*" />
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
	prefix="carbon"%>
<jsp:include page="../dialog/display_messages.jsp"/>
<jsp:include page="../highlighter/header.jsp"/>
<%
    String resourceNames = "";
    String subjectNames = "";
    String attributeId = "";
    String userAttributeValue = "";
    String actionNames = "";
    String environmentNames = "";

    BasicRequestDTO basicRequestDTO = entitlementPolicyBean.getBasicRequestDTO();
    ClaimDialectDTO claimDialectDTO = null;

    String BUNDLE = "org.wso2.carbon.identity.entitlement.ui.i18n.Resources";
	ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());

    resourceNames = (String)session.getAttribute("resourceNames");
    subjectNames = (String)session.getAttribute("subjectNames");
    attributeId = (String)session.getAttribute("attributeId");
    userAttributeValue = (String)session.getAttribute("userAttributeValue");
    actionNames = (String)session.getAttribute("actionNames");
    environmentNames = (String)session.getAttribute("environmentNames");


    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.
                    CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);    
    String forwardTo;
    try {
        ClaimAdminClient claimAdminClient = new ClaimAdminClient(cookie, serverURL,
                configContext);
        claimDialectDTO =claimAdminClient.getAllClaimMappingsByDialectWithRole(EntitlementPolicyConstants.DEFAULT_CARBON_DIALECT);

    } catch (Exception e) {
    	String message = resourceBundle.getString("error.while.loading.policy.resource");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "../admin/error.jsp";

%>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
<%
    }
%>


<fmt:bundle basename="org.wso2.carbon.identity.entitlement.ui.i18n.Resources">
<carbon:breadcrumb
		label="create.evaluation.request"
		resourceBundle="org.wso2.carbon.identity.entitlement.ui.i18n.Resources"
		topPage="false"
		request="<%=request%>" />

    <script type="text/javascript" src="../carbon/admin/js/breadcrumbs.js"></script>
    <script type="text/javascript" src="../carbon/admin/js/cookies.js"></script>
    <script type="text/javascript" src="resources/js/main.js"></script>
    <!--Yahoo includes for dom event handling-->
    <script src="../yui/build/yahoo-dom-event/yahoo-dom-event.js" type="text/javascript"></script>
    <script src="../entitlement/js/create-basic-policy.js" type="text/javascript"></script>
    <link href="../entitlement/css/entitlement.css" rel="stylesheet" type="text/css" media="all"/>

<script type="text/javascript">

    function submitForm(){
        document.requestForm.action = "eval-policy-submit.jsp?";
        document.requestForm.submit();
    }

    function doCancel(){
        location.href = 'index.jsp?';
    }

    function createRequest(){
        document.requestForm.action = "eval-policy.jsp?";
        document.requestForm.submit();
    }

</script>

<div id="middle">
    <h2><fmt:message key="eval.ent.policy"/></h2>
    <div id="workArea">
        <div class="goToAdvance">
            <a class='icon-link' href="../entitlement/eval-policy.jsp"
                       style='background-image:url(images/advanceview.png);float:none'><fmt:message key="create.request.using.editor"/></a>
        </div>
        <form id="requestForm" name="requestForm" method="post" action="">
        <table class="styledLeft noBorders">
        <tr>
            <td><fmt:message key='resource.names.are'/></td>
            <td colspan="2">
            <%
                if (resourceNames != null && resourceNames.trim().length() > 0) {
            %>
            <input type="text" size="60" name="resourceNames" id="resourceNames"
                       value="<%=resourceNames%>" class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" size="60" name="resourceNames" id="resourceNames"
                       class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>

        <tr>
            <td class="leftCol-small"><fmt:message key='subject.name'/></td>
            <td colspan="2">
            <%
                if (subjectNames != null && subjectNames.trim().length() > 0) {
            %>
            <input type="text" name="subjectNames" id="subjectNames"
                       value="<%=subjectNames%>" class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" name="subjectNames" id="subjectNames" class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>

      <tr>
            <td class="leftCol-small"><fmt:message key='subject.attribute'/></td>
            <td colspan="2">
                <select id="attributeId" name="attributeId" class="text-box-big">
                    <%
                        if (claimDialectDTO != null && claimDialectDTO.getClaimMappings() != null) {
                            for (ClaimMappingDTO claimMappingDTO : claimDialectDTO.getClaimMappings()) {
                                String claimUri = claimMappingDTO.getClaim().getClaimUri();
                                if (attributeId != null && claimUri.equals(attributeId)) {
                    %>
                        <option value="<%=claimUri%>" selected="selected"><%=attributeId%></option>
                    <%
                                } else {
                    %>
                        <option value="<%=claimUri%>"><%=claimUri%></option>
                    <%
                                }
                            }
                        }
                    %>
                </select>
                </td>

        </tr>
        <tr>
            <td class="leftCol-small"><fmt:message key='subject.attribute.value'/></td>
 
                <td  colspan="2">
                <%
                    if (userAttributeValue != null && userAttributeValue.trim().length() > 0) {
                %>
                <input type="text" name="userAttributeValue" id="userAttributeValue"
                       value="<%=userAttributeValue%>" class="text-box-big" />
                <%
                    } else {
                %>
                <input type="text" name="userAttributeValue" id="userAttributeValue"  class="text-box-big" <%--onFocus="handleFocus(this,'User attribute')" onBlur="handleBlur(this,'User attribute');" class="defaultText text-box-big"--%>/>
                <%
                    }
                %>
            </td>
        </tr>

        <tr>
            <td class="leftCol-small"><fmt:message key='action.names'/></td>
            <td colspan="2">
            <%
                if (actionNames != null && actionNames.trim().length() > 0) {
            %>
            <input type="text" name="actionNames" id="actionNames" value="<%=actionNames%>"
                       class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" name="actionNames" id="actionNames" class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>            

        <tr>
            <td class="leftCol-small"><fmt:message key='environment.names'/></td>
            <td colspan="2">
            <%
                if (environmentNames != null && environmentNames.trim().length() > 0) {
            %>
            <input type="text" name="environmentNames" id="environmentNames" value="<%=environmentNames%>"
                       class="text-box-big"/>
            <%
                } else {
            %>
            <input type="text" name="environmentNames" id="environmentNames" class="text-box-big"/>
            <%
                }
            %>
            </td>
        </tr>


        <tr>
            <td class="buttonRow" colspan="3">
                <input type="button" onclick="submitForm();" value="<fmt:message key="evaluate"/>"  class="button"/>
                <input type="button" onclick="createRequest();" value="<fmt:message key="create.request"/>"  class="button"/>
            </td>
        </tr>
        </table>
        </form>
    </div>
</div>
</fmt:bundle>
